/*
 *         
 * SmoothAlgorithms.mqh
 *   (): MetaTrader\\MQL5\Include
 */
//+X================================================================X+
//|                                                          EMA.mq5 |
//|                               Copyright  2010, Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+
#property copyright "2010,   Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"

//----     
#property indicator_chart_window
//----        
#property indicator_buffers 1
//----     
#property indicator_plots   1
//----     
#property indicator_type1   DRAW_LINE
//----        
#property indicator_color1  LimeGreen

//----   
input double EMAPeriod = 13; //  EMA
input int    EMAShift = 0; //  EMA    
input int    EMAPriceShift = 0; // EMA     

//---  
double ExtLineBuffer[];

double dPriceShift;
//+X================================================================X+
//| Custom indicator initialization function                         |
//+X================================================================X+
void OnInit()
  {
//----+
   //----         
   string short_name = "EMA";
   IndicatorSetString(INDICATOR_SHORTNAME, short_name + "(" + string(EMAPeriod) + ")");  
   //----   ,      
   PlotIndexSetDouble(0, PLOT_EMPTY_VALUE, EMPTY_VALUE);
   //----    ExtLineBuffer   
   SetIndexBuffer(0, ExtLineBuffer, INDICATOR_DATA);
   //----        MAShift
   PlotIndexSetInteger(0, PLOT_SHIFT, EMAShift);
   //----     
   IndicatorSetInteger(INDICATOR_DIGITS, _Digits + 1);
   //----    
   dPriceShift = _Point * EMAPriceShift;
//----+
  }
//+X================================================================X+
//   CMoving_Average                                   | 
//+X================================================================X+ 
#include <SmoothAlgorithms.mqh> 
//+X================================================================X+ 
//|  Moving Average                                                  |
//+X================================================================X+
int OnCalculate
               (
                const int rates_total, //       
                const int prev_calculated, //       
                const int begin, //     
                const double &price[] //     
               ) 
  {
//----+   
   //----       
   if (rates_total < begin)
    return(0);
   
   //----    
   int first, bar;
   
   //----    first    
   if (prev_calculated == 0) //      
    {
     first = begin; //      
     for(bar = 0; bar <= begin; bar++)
       ExtLineBuffer[bar] = 0;
    }
   else first = prev_calculated - 1; //      
   
   //----    CMoving_Average   MASeries_Cls.mqh
   static CMoving_Average EMA;
   
   //----    
   for(bar = first; bar < rates_total; bar++)
    {
     //----   .    EMASeries.  
     ExtLineBuffer[bar] = EMA.EMASeries(begin, prev_calculated, rates_total, EMAPeriod, price[bar], bar, false) + dPriceShift;
    }
//----+     
   return(rates_total);
  }
//+X----------------------+ <<< The End >>> +-----------------------X+
